From 14c3a1df5c0e5b82ef82e150e0c827d1cbca57fe Mon Sep 17 00:00:00 2001
From: "Erich E. Hoover" <erich.e.hoover@gmail.com>
Date: Thu, 11 Feb 2021 15:27:51 -0700
Subject: ntdll: Use st_rdev for special devices in get_mountmgr_fs_info.

Signed-off-by: Erich E. Hoover <erich.e.hoover@gmail.com>
---
 dlls/ntdll/unix/file.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/dlls/ntdll/unix/file.c b/dlls/ntdll/unix/file.c
index 6337433ed80..e147fb47391 100644
--- a/dlls/ntdll/unix/file.c
+++ b/dlls/ntdll/unix/file.c
@@ -1968,7 +1968,7 @@ static NTSTATUS get_mountmgr_fs_info( HANDLE handle, int fd, struct mountmgr_uni
         struct stat st;
 
         fstat( fd, &st );
-        drive->unix_dev = st.st_dev;
+        drive->unix_dev = st.st_rdev ? st.st_rdev : st.st_dev;
         drive->letter = 0;
     }
     else
-- 
2.17.1