Index: wine/dlls/commdlg/filedlg95.c
===================================================================
RCS file: /home/wine/wine/dlls/commdlg/filedlg95.c,v
retrieving revision 1.85
diff -u -u -r1.85 filedlg95.c
--- wine/dlls/commdlg/filedlg95.c	2 Dec 2002 18:10:59 -0000	1.85
+++ wine/dlls/commdlg/filedlg95.c	5 Dec 2002 13:25:43 -0000
@@ -769,7 +769,7 @@
 {
     FileOpenDlgInfos *fodInfos = (FileOpenDlgInfos *) GetPropA(hwndParentDlg,FileOpenDlgInfosStr);
 
-    TRACE("0x%p 0x%04x\n",hwndParentDlg, uCode);
+    TRACE("%p 0x%04x\n",hwndParentDlg, uCode);
 
     if(!fodInfos) return 0;
 
@@ -1587,7 +1587,7 @@
   int nOpenAction;
   FileOpenDlgInfos *fodInfos = (FileOpenDlgInfos *) GetPropA(hwnd,FileOpenDlgInfosStr);
 
-  TRACE("hwnd=0x%p\n", hwnd);
+  TRACE("hwnd=%p\n", hwnd);
 
   /* get the files from the edit control */
   nFileCount = FILEDLG95_FILENAME_GetFileNames(hwnd, &lpstrFileList, &sizeUsed);
@@ -1974,7 +1974,7 @@
   FileOpenDlgInfos *fodInfos = (FileOpenDlgInfos *) GetPropA(hwnd,FileOpenDlgInfosStr);
 
   IContextMenu * pcm;
-  TRACE("(0x%p,%p)\n", hwnd, lpVerb);
+  TRACE("(%p,%p)\n", hwnd, lpVerb);
 
   if(SUCCEEDED(IShellView_GetItemObject(fodInfos->Shell.FOIShellView,
 					SVGIO_BACKGROUND,
Index: wine/dlls/ntdll/file.c
===================================================================
RCS file: /home/wine/wine/dlls/ntdll/file.c,v
retrieving revision 1.18
diff -u -u -r1.18 file.c
--- wine/dlls/ntdll/file.c	21 Nov 2002 03:45:03 -0000	1.18
+++ wine/dlls/ntdll/file.c	5 Dec 2002 13:25:43 -0000
@@ -210,7 +210,7 @@
 	int fd, result, flags, ret;
 	enum fd_type type;
 
-	FIXME("(0x%p,0x%p,%p,%p,%p,%p,0x%08lx,%p,%p),partial stub!\n",
+	FIXME("(%p,%p,%p,%p,%p,%p,0x%08lx,%p,%p),partial stub!\n",
 		FileHandle,EventHandle,ApcRoutine,ApcContext,IoStatusBlock,Buffer,Length,ByteOffset,Key);
 
 	if (IsBadWritePtr( Buffer, Length ) ||
@@ -273,7 +273,7 @@
 	PLARGE_INTEGER ByteOffset,
 	PULONG Key)
 {
-	FIXME("(0x%p,0x%p,%p,%p,%p,%p,0x%08lx,%p,%p),stub!\n",
+	FIXME("(%p,%p,%p,%p,%p,%p,0x%08lx,%p,%p),stub!\n",
 	FileHandle,EventHandle,ApcRoutine,ApcContext,IoStatusBlock,Buffer,Length,ByteOffset,Key);
 	return 0;
 }
@@ -294,7 +294,7 @@
 	OUT PVOID OutputBuffer,
 	IN ULONG OutputBufferSize)
 {
-	FIXME("(0x%p,0x%p,%p,%p,%p,0x%08lx,%p,0x%08lx,%p,0x%08lx): empty stub\n",
+	FIXME("(%p,%p,%p,%p,%p,0x%08lx,%p,0x%08lx,%p,0x%08lx): empty stub\n",
 	DeviceHandle, Event, UserApcRoutine, UserApcContext,
 	IoStatusBlock, IoControlCode, InputBuffer, InputBufferSize, OutputBuffer, OutputBufferSize);
 	return 0;
@@ -316,7 +316,7 @@
 	OUT PVOID OutputBuffer,
 	IN ULONG OutputBufferSize)
 {
-	FIXME("(0x%p,0x%p,%p,%p,%p,0x%08lx,%p,0x%08lx,%p,0x%08lx): stub\n",
+	FIXME("(%p,%p,%p,%p,%p,0x%08lx,%p,0x%08lx,%p,0x%08lx): stub\n",
 	DeviceHandle,Event,ApcRoutine,ApcContext,IoStatusBlock,IoControlCode,
 	InputBuffer,InputBufferSize,OutputBuffer,OutputBufferSize);
 	return 0;
@@ -333,7 +333,7 @@
         ULONG Length,
 	FS_INFORMATION_CLASS FsInformationClass)
 {
-	FIXME("(0x%p,%p,%p,0x%08lx,0x%08x) stub\n",
+	FIXME("(%p,%p,%p,0x%08lx,0x%08x) stub\n",
 	FileHandle,IoStatusBlock,FsInformation,Length,FsInformationClass);
 	return 0;
 }
@@ -349,7 +349,7 @@
 	ULONG Length,
 	FILE_INFORMATION_CLASS FileInformationClass)
 {
-	FIXME("(0x%p,%p,%p,0x%08lx,0x%08x),stub!\n",
+	FIXME("(%p,%p,%p,0x%08lx,0x%08x),stub!\n",
 	FileHandle,IoStatusBlock,FileInformation,Length,FileInformationClass);
 	return 0;
 }
@@ -365,7 +365,7 @@
 	ULONG Length,
 	FILE_INFORMATION_CLASS FileInformationClass)
 {
-	FIXME("(0x%p,%p,%p,0x%08lx,0x%08x)\n",
+	FIXME("(%p,%p,%p,0x%08lx,0x%08x)\n",
 	FileHandle,IoStatusBlock,FileInformation,Length,FileInformationClass);
 	return 0;
 }
@@ -388,7 +388,7 @@
 	IN PUNICODE_STRING FileName OPTIONAL,
 	IN BOOLEAN RestartScan)
 {
-	FIXME("(0x%p 0x%p %p %p %p %p 0x%08lx 0x%08x 0x%08x %p 0x%08x\n",
+	FIXME("(%p %p %p %p %p %p 0x%08lx 0x%08x 0x%08x %p 0x%08x\n",
 	FileHandle, Event, ApcRoutine, ApcContext, IoStatusBlock, FileInformation,
 	Length, FileInformationClass, ReturnSingleEntry,
 	debugstr_us(FileName),RestartScan);
@@ -408,7 +408,7 @@
 {
 	ULONG len = 0;
 
-	FIXME("(0x%p %p %p 0x%08lx 0x%08x) stub!\n",
+	FIXME("(%p %p %p 0x%08lx 0x%08x) stub!\n",
 	FileHandle, IoStatusBlock, FSInformation, Length, FSInformationClass);
 
 	switch ( FSInformationClass )
Index: wine/dlls/ntdll/heap.c
===================================================================
RCS file: /home/wine/wine/dlls/ntdll/heap.c,v
retrieving revision 1.12
diff -u -u -r1.12 heap.c
--- wine/dlls/ntdll/heap.c	21 Nov 2002 03:45:03 -0000	1.12
+++ wine/dlls/ntdll/heap.c	5 Dec 2002 13:25:44 -0000
@@ -1332,7 +1332,7 @@
 
     if (!entry->lpData) /* first call (init) ? */
     {
-        TRACE("begin walking of heap 0x%p.\n", heap);
+        TRACE("begin walking of heap %p.\n", heap);
         currentheap = &heapPtr->subheap;
         ptr = (char*)currentheap + currentheap->headerSize;
     }
Index: wine/dlls/ntdll/misc.c
===================================================================
RCS file: /home/wine/wine/dlls/ntdll/misc.c,v
retrieving revision 1.16
diff -u -u -r1.16 misc.c
--- wine/dlls/ntdll/misc.c	21 Nov 2002 03:45:03 -0000	1.16
+++ wine/dlls/ntdll/misc.c	5 Dec 2002 13:25:44 -0000
@@ -36,7 +36,7 @@
 void dump_ObjectAttributes (const OBJECT_ATTRIBUTES *oa)
 {
 	if (oa)
-	  TRACE("%p:(name=%s, attr=0x%08lx, hRoot=0x%p, sd=%p) \n",
+	  TRACE("%p:(name=%s, attr=0x%08lx, hRoot=%p, sd=%p) \n",
 	    oa, debugstr_us(oa->ObjectName),
 	    oa->Attributes, oa->RootDirectory, oa->SecurityDescriptor);
 }
Index: wine/dlls/ntdll/nt.c
===================================================================
RCS file: /home/wine/wine/dlls/ntdll/nt.c,v
retrieving revision 1.46
diff -u -u -r1.46 nt.c
--- wine/dlls/ntdll/nt.c	21 Nov 2002 03:45:03 -0000	1.46
+++ wine/dlls/ntdll/nt.c	5 Dec 2002 13:25:44 -0000
@@ -65,7 +65,7 @@
 	IN ULONG Period OPTIONAL,
 	OUT PBOOLEAN PreviousState OPTIONAL)
 {
-	FIXME("(0x%p,%p,%p,%p,%08x,0x%08lx,%p) stub\n",
+	FIXME("(%p,%p,%p,%p,%08x,0x%08lx,%p) stub\n",
 	TimerHandle,DueTime,TimerApcRoutine,TimerContext,WakeTimer,Period,PreviousState);
 	return 0;
 }
@@ -132,7 +132,7 @@
 			ret = STATUS_INFO_LENGTH_MISMATCH;
 		break;
 	default:
-		FIXME("(0x%p,0x%08x,%p,0x%08lx,%p),stub!\n",
+		FIXME("(%p,0x%08x,%p,0x%08lx,%p),stub!\n",
 			ProcessHandle,ProcessInformationClass,
 			ProcessInformation,ProcessInformationLength,
 			ReturnLength
@@ -156,7 +156,7 @@
 	IN PVOID ProcessInformation,
 	IN ULONG ProcessInformationLength)
 {
-	FIXME("(0x%p,0x%08x,%p,0x%08lx) stub\n",
+	FIXME("(%p,0x%08x,%p,0x%08lx) stub\n",
 	ProcessHandle,ProcessInformationClass,ProcessInformation,ProcessInformationLength);
 	return 0;
 }
@@ -173,7 +173,7 @@
 	IN HANDLE ThreadHandle,
 	IN PULONG SuspendCount)
 {
-	FIXME("(0x%p,%p),stub!\n",
+	FIXME("(%p,%p),stub!\n",
 	ThreadHandle,SuspendCount);
 	return 0;
 }
@@ -219,7 +219,7 @@
 	IN ULONG ThreadInformationLength,
 	OUT PULONG ReturnLength)
 {
-	FIXME("(0x%p,0x%08x,%p,0x%08lx,%p),stub!\n",
+	FIXME("(%p,0x%08x,%p,0x%08lx,%p),stub!\n",
 		ThreadHandle, ThreadInformationClass, ThreadInformation,
 		ThreadInformationLength, ReturnLength);
 	return 0;
@@ -235,7 +235,7 @@
 	PVOID ThreadInformation,
 	ULONG ThreadInformationLength)
 {
-	FIXME("(0x%p,0x%08x,%p,0x%08lx),stub!\n",
+	FIXME("(%p,0x%08x,%p,0x%08lx),stub!\n",
 	ThreadHandle, ThreadInformationClass, ThreadInformation, ThreadInformationLength);
 	return 0;
 }
@@ -256,7 +256,7 @@
         IN TOKEN_TYPE TokenType,
         OUT PHANDLE NewToken)
 {
-	FIXME("(0x%p,0x%08lx,%p,0x%08x,0x%08x,%p),stub!\n",
+	FIXME("(%p,0x%08lx,%p,0x%08x,0x%08x,%p),stub!\n",
 	ExistingToken, DesiredAccess, ObjectAttributes,
 	ImpersonationLevel, TokenType, NewToken);
 	dump_ObjectAttributes(ObjectAttributes);
@@ -272,7 +272,7 @@
 	DWORD DesiredAccess,
 	HANDLE *TokenHandle)
 {
-	FIXME("(0x%p,0x%08lx,%p): stub\n",
+	FIXME("(%p,0x%08lx,%p): stub\n",
 	ProcessHandle,DesiredAccess, TokenHandle);
 	*TokenHandle = (HANDLE)0xcafe;
 	return 0;
@@ -288,7 +288,7 @@
 	BOOLEAN OpenAsSelf,
 	HANDLE *TokenHandle)
 {
-	FIXME("(0x%p,0x%08lx,0x%08x,%p): stub\n",
+	FIXME("(%p,0x%08lx,0x%08x,%p): stub\n",
 	ThreadHandle,DesiredAccess, OpenAsSelf, TokenHandle);
 	*TokenHandle = (HANDLE)0xcafe;
 	return 0;
@@ -308,7 +308,7 @@
 	OUT PTOKEN_PRIVILEGES PreviousState,
 	OUT PDWORD ReturnLength)
 {
-	FIXME("(0x%p,0x%08x,%p,0x%08lx,%p,%p),stub!\n",
+	FIXME("(%p,0x%08x,%p,0x%08lx,%p,%p),stub!\n",
 	TokenHandle, DisableAllPrivileges, NewState, BufferLength, PreviousState, ReturnLength);
 	return 0;
 }
@@ -427,7 +427,7 @@
 	IN ULONG Length,
 	OUT PULONG ResultLength)
 {
-	FIXME("(0x%p,%p,%p,0x%08lx,%p) stub!\n",
+	FIXME("(%p,%p,%p,0x%08lx,%p) stub!\n",
 	SectionHandle,SectionInformationClass,SectionInformation,Length,ResultLength);
 	return 0;
 }
Index: wine/dlls/ntdll/om.c
===================================================================
RCS file: /home/wine/wine/dlls/ntdll/om.c,v
retrieving revision 1.23
diff -u -u -r1.23 om.c
--- wine/dlls/ntdll/om.c	21 Nov 2002 03:45:03 -0000	1.23
+++ wine/dlls/ntdll/om.c	5 Dec 2002 13:25:44 -0000
@@ -54,7 +54,7 @@
 	IN ULONG Length,
 	OUT PULONG ResultLength)
 {
-	FIXME("(0x%p,0x%08x,%p,0x%08lx,%p): stub\n",
+	FIXME("(%p,0x%08x,%p,0x%08lx,%p): stub\n",
 	ObjectHandle, ObjectInformationClass, ObjectInformation, Length, ResultLength);
 	return 0;
 }
@@ -85,7 +85,7 @@
 	PISECURITY_DESCRIPTOR_RELATIVE psd = (PISECURITY_DESCRIPTOR_RELATIVE)Buffer;
 	UINT BufferIndex = sizeof(SECURITY_DESCRIPTOR_RELATIVE);
 
-	FIXME("(0x%p,0x%08lx,%p,0x%08lx,%p) stub!\n",
+	FIXME("(%p,0x%08lx,%p,0x%08lx,%p) stub!\n",
 	Object, RequestedInformation, pSecurityDesriptor, Length, ResultLength);
 
 	RequestedInformation &= 0x0000000f;
@@ -271,7 +271,7 @@
 	IN BOOLEAN Alertable,
 	IN PLARGE_INTEGER Time)
 {
-	FIXME("(0x%p,0x%08x,%p),stub!\n",Object,Alertable,Time);
+	FIXME("(%p,0x%08x,%p),stub!\n",Object,Alertable,Time);
 	return 0;
 }
 
@@ -338,7 +338,7 @@
 	IN OUT PULONG ObjectIndex,
 	OUT PULONG DataWritten OPTIONAL)
 {
-	FIXME("(0x%p,%p,0x%08lx,0x%08x,0x%08x,%p,%p) stub\n",
+	FIXME("(%p,%p,0x%08lx,0x%08x,0x%08x,%p,%p) stub\n",
 		DirObjHandle, DirObjInformation, BufferLength, GetNextIndex,
 		IgnoreInputIndex, ObjectIndex, DataWritten);
     return 0xc0000000; /* We don't have any. Whatever. (Yet.) */
@@ -385,7 +385,7 @@
 	IN OUT PUNICODE_STRING LinkTarget,
 	OUT PULONG ReturnedLength OPTIONAL)
 {
-	FIXME("(0x%p,%p,%p) stub\n",
+	FIXME("(%p,%p,%p) stub\n",
 	LinkHandle, debugstr_us(LinkTarget), ReturnedLength);
 
 	return 0;
Index: wine/dlls/ntdll/reg.c
===================================================================
RCS file: /home/wine/wine/dlls/ntdll/reg.c,v
retrieving revision 1.42
diff -u -u -r1.42 reg.c
--- wine/dlls/ntdll/reg.c	21 Nov 2002 03:45:03 -0000	1.42
+++ wine/dlls/ntdll/reg.c	5 Dec 2002 13:25:44 -0000
@@ -55,7 +55,7 @@
 {
     NTSTATUS ret;
 
-    TRACE( "(0x%p,%s,%s,%lx,%lx,%p)\n", attr->RootDirectory, debugstr_us(attr->ObjectName),
+    TRACE( "(%p,%s,%s,%lx,%lx,%p)\n", attr->RootDirectory, debugstr_us(attr->ObjectName),
            debugstr_us(class), options, access, retkey );
 
     if (attr->ObjectName->Length > MAX_NAME_LENGTH) return STATUS_BUFFER_OVERFLOW;
@@ -77,7 +77,7 @@
         }
     }
     SERVER_END_REQ;
-    TRACE("<- 0x%p\n", *retkey);
+    TRACE("<- %p\n", *retkey);
     return ret;
 }
 
@@ -95,7 +95,7 @@
     NTSTATUS ret;
     DWORD len = attr->ObjectName->Length;
 
-    TRACE( "(0x%p,%s,%lx,%p)\n", attr->RootDirectory,
+    TRACE( "(%p,%s,%lx,%p)\n", attr->RootDirectory,
            debugstr_us(attr->ObjectName), access, retkey );
 
     if (len > MAX_NAME_LENGTH) return STATUS_BUFFER_OVERFLOW;
@@ -110,7 +110,7 @@
         *retkey = reply->hkey;
     }
     SERVER_END_REQ;
-    TRACE("<- 0x%p\n", *retkey);
+    TRACE("<- %p\n", *retkey);
     return ret;
 }
 
@@ -143,7 +143,7 @@
 {
     NTSTATUS ret;
 
-    TRACE( "(0x%p,%s)\n", hkey, debugstr_us(name) );
+    TRACE( "(%p,%s)\n", hkey, debugstr_us(name) );
     if (name->Length > MAX_NAME_LENGTH) return STATUS_BUFFER_OVERFLOW;
 
     SERVER_START_REQ( delete_key_value )
@@ -328,7 +328,7 @@
     void *ptr;
     size_t fixed_size;
 
-    TRACE( "(0x%p,%lu,%d,%p,%ld)\n", handle, index, info_class, info, length );
+    TRACE( "(%p,%lu,%d,%p,%ld)\n", handle, index, info_class, info, length );
 
     /* compute the length we want to retrieve */
     switch(info_class)
@@ -376,7 +376,7 @@
     UCHAR *data_ptr;
     int fixed_size = 0;
 
-    TRACE( "(0x%p,%s,%d,%p,%ld)\n", handle, debugstr_us(name), info_class, info, length );
+    TRACE( "(%p,%s,%d,%p,%ld)\n", handle, debugstr_us(name), info_class, info, length );
 
     if (name->Length > MAX_NAME_LENGTH) return STATUS_BUFFER_OVERFLOW;
 
@@ -424,7 +424,7 @@
  */
 NTSTATUS WINAPI NtFlushKey(HKEY KeyHandle)
 {
-	FIXME("(0x%p) stub!\n",
+	FIXME("(%p) stub!\n",
 	KeyHandle);
 	return 1;
 }
@@ -457,7 +457,7 @@
 	IN ULONG Length,
 	IN BOOLEAN WatchSubtree)
 {
-	FIXME("(0x%p,0x%p,%p,%p,%p,0x%08lx, 0x%08x,%p,0x%08lx,0x%08x) stub!\n",
+	FIXME("(%p,%p,%p,%p,%p,0x%08lx, 0x%08x,%p,0x%08lx,0x%08x) stub!\n",
 	KeyHandle, Event, ApcRoutine, ApcContext, IoStatusBlock, CompletionFilter,
 	Asynchroneous, ChangeBuffer, Length, WatchSubtree);
 	return STATUS_SUCCESS;
@@ -476,7 +476,7 @@
 	ULONG Length,
 	PULONG  ReturnLength)
 {
-	FIXME("(0x%p,%p,0x%08lx,%p,0x%08lx,%p) stub!\n",
+	FIXME("(%p,%p,0x%08lx,%p,0x%08lx,%p) stub!\n",
 	KeyHandle, ListOfValuesToQuery, NumberOfItems, MultipleValueInformation,
 	Length,ReturnLength);
 	return STATUS_SUCCESS;
@@ -491,7 +491,7 @@
 	IN HKEY Key,
 	IN POBJECT_ATTRIBUTES ReplacedObjectAttributes)
 {
-	FIXME("(0x%p),stub!\n", Key);
+	FIXME("(%p),stub!\n", Key);
 	dump_ObjectAttributes(ObjectAttributes);
 	dump_ObjectAttributes(ReplacedObjectAttributes);
 	return STATUS_SUCCESS;
@@ -505,7 +505,7 @@
 	HANDLE FileHandle,
 	ULONG RestoreFlags)
 {
-	FIXME("(0x%p,0x%p,0x%08lx) stub\n",
+	FIXME("(%p,%p,0x%08lx) stub\n",
 	KeyHandle, FileHandle, RestoreFlags);
 	return STATUS_SUCCESS;
 }
@@ -517,7 +517,7 @@
 	IN HKEY KeyHandle,
 	IN HANDLE FileHandle)
 {
-	FIXME("(0x%p,0x%p) stub\n",
+	FIXME("(%p,%p) stub\n",
 	KeyHandle, FileHandle);
 	return STATUS_SUCCESS;
 }
@@ -531,7 +531,7 @@
 	IN PVOID KeyInformation,
 	IN ULONG KeyInformationLength)
 {
-	FIXME("(0x%p,0x%08x,%p,0x%08lx) stub\n",
+	FIXME("(%p,0x%08x,%p,0x%08lx) stub\n",
 	KeyHandle, KeyInformationClass, KeyInformation, KeyInformationLength);
 	return STATUS_SUCCESS;
 }
@@ -550,7 +550,7 @@
 {
     NTSTATUS ret;
 
-    TRACE( "(0x%p,%s,%ld,%p,%ld)\n", hkey, debugstr_us(name), type, data, count );
+    TRACE( "(%p,%s,%ld,%p,%ld)\n", hkey, debugstr_us(name), type, data, count );
 
     if (name->Length > MAX_NAME_LENGTH) return STATUS_BUFFER_OVERFLOW;
 
@@ -574,7 +574,7 @@
 NTSTATUS WINAPI NtUnloadKey(
 	IN HKEY KeyHandle)
 {
-	FIXME("(0x%p) stub\n",
+	FIXME("(%p) stub\n",
 	KeyHandle);
 	return STATUS_SUCCESS;
 }
Index: wine/dlls/ntdll/sec.c
===================================================================
RCS file: /home/wine/wine/dlls/ntdll/sec.c,v
retrieving revision 1.30
diff -u -u -r1.30 sec.c
--- wine/dlls/ntdll/sec.c	21 Nov 2002 03:45:03 -0000	1.30
+++ wine/dlls/ntdll/sec.c	5 Dec 2002 13:25:45 -0000
@@ -709,7 +709,7 @@
         IN SECURITY_INFORMATION SecurityInformation,
         IN PSECURITY_DESCRIPTOR SecurityDescriptor)
 {
-	FIXME("0x%p 0x%08lx %p\n", Handle, SecurityInformation, SecurityDescriptor);
+	FIXME("%p 0x%08lx %p\n", Handle, SecurityInformation, SecurityDescriptor);
 	return STATUS_SUCCESS;
 }
 
Index: wine/dlls/ntdll/sync.c
===================================================================
RCS file: /home/wine/wine/dlls/ntdll/sync.c,v
retrieving revision 1.22
diff -u -u -r1.22 sync.c
--- wine/dlls/ntdll/sync.c	21 Nov 2002 03:45:03 -0000	1.22
+++ wine/dlls/ntdll/sync.c	5 Dec 2002 13:25:45 -0000
@@ -97,7 +97,7 @@
 	ULONG Length,
 	PULONG ReturnLength)
 {
-	FIXME("(0x%p,%p,%p,0x%08lx,%p) stub!\n",
+	FIXME("(%p,%p,%p,0x%08lx,%p) stub!\n",
 	SemaphoreHandle, SemaphoreInformationClass, SemaphoreInformation, Length, ReturnLength);
 	return STATUS_SUCCESS;
 }
@@ -237,7 +237,7 @@
 NTSTATUS WINAPI NtPulseEvent( HANDLE handle, PULONG PulseCount )
 {
     NTSTATUS ret;
-    FIXME("(0x%p,%p)\n", handle, PulseCount);
+    FIXME("(%p,%p)\n", handle, PulseCount);
     SERVER_START_REQ( event_op )
     {
         req->handle = handle;
@@ -258,6 +258,6 @@
 	IN  ULONG EventInformationLength,
 	OUT PULONG  ReturnLength)
 {
-	FIXME("(0x%p)\n", EventHandle);
+	FIXME("(%p)\n", EventHandle);
 	return STATUS_SUCCESS;
 }
Index: wine/loader/module.c
===================================================================
RCS file: /home/wine/wine/loader/module.c,v
retrieving revision 1.169
diff -u -u -r1.169 module.c
--- wine/loader/module.c	21 Nov 2002 03:45:02 -0000	1.169
+++ wine/loader/module.c	5 Dec 2002 13:25:46 -0000
@@ -85,7 +85,7 @@
     	return exe_modref;
 
     if (!HIWORD(hmod)) {
-    	ERR("tried to lookup 0x%p in win32 module handler!\n",hmod);
+    	ERR("tried to lookup %p in win32 module handler!\n",hmod);
         SetLastError( ERROR_INVALID_HANDLE );
 	return NULL;
     }
@@ -1262,7 +1262,7 @@
                     pwm->flags &= ~WINE_MODREF_DONT_RESOLVE_REFS;
                     PE_fixup_imports( pwm );
 		}
-		TRACE("Already loaded module '%s' at 0x%p, count=%d\n", filename, pwm->module, pwm->refCount);
+		TRACE("Already loaded module '%s' at %p, count=%d\n", filename, pwm->module, pwm->refCount);
                 if (allocated_libdir)
                 {
                     HeapFree ( GetProcessHeap(), 0, (LPSTR)libdir );
@@ -1308,7 +1308,7 @@
 		if(pwm)
 		{
 			/* Initialize DLL just loaded */
-			TRACE("Loaded module '%s' at 0x%p\n", filename, pwm->module);
+			TRACE("Loaded module '%s' at %p\n", filename, pwm->module);
                         if (!TRACE_ON(module))
                             TRACE_(loaddll)("Loaded module '%s' : %s\n", filename, filetype);
 			/* Set the refCount here so that an attach failure will */
Index: wine/scheduler/process.c
===================================================================
RCS file: /home/wine/wine/scheduler/process.c,v
retrieving revision 1.204
diff -u -u -r1.204 process.c
--- wine/scheduler/process.c	3 Dec 2002 23:28:15 -0000	1.204
+++ wine/scheduler/process.c	5 Dec 2002 13:25:47 -0000
@@ -1658,7 +1658,7 @@
 BOOL WINAPI SetProcessWorkingSetSize(HANDLE hProcess, SIZE_T minset,
                                      SIZE_T maxset)
 {
-    FIXME("(0x%p,%ld,%ld): stub - harmless\n",hProcess,minset,maxset);
+    FIXME("(%p,%ld,%ld): stub - harmless\n",hProcess,minset,maxset);
     if(( minset == (SIZE_T)-1) && (maxset == (SIZE_T)-1)) {
         /* Trim the working set to zero */
         /* Swap the process out of physical RAM */
@@ -1672,7 +1672,7 @@
 BOOL WINAPI GetProcessWorkingSetSize(HANDLE hProcess, PSIZE_T minset,
                                      PSIZE_T maxset)
 {
-	FIXME("(0x%p,%p,%p): stub\n",hProcess,minset,maxset);
+	FIXME("(%p,%p,%p): stub\n",hProcess,minset,maxset);
 	/* 32 MB working set size */
 	if (minset) *minset = 32*1024*1024;
 	if (maxset) *maxset = 32*1024*1024;
Index: wine/scheduler/thread.c
===================================================================
RCS file: /home/wine/wine/scheduler/thread.c,v
retrieving revision 1.127
diff -u -u -r1.127 thread.c
--- wine/scheduler/thread.c	30 Nov 2002 01:56:56 -0000	1.127
+++ wine/scheduler/thread.c	5 Dec 2002 13:25:47 -0000
@@ -565,7 +565,7 @@
     HANDLE hThread,          /* [in] Specifies the thread of interest */
     DWORD dwIdealProcessor)  /* [in] Specifies the new preferred processor */
 {
-    FIXME("(0x%p): stub\n",hThread);
+    FIXME("(%p): stub\n",hThread);
     SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
     return -1L;
 }
Index: wine/win32/device.c
===================================================================
RCS file: /home/wine/wine/win32/device.c,v
retrieving revision 1.74
diff -u -u -r1.74 device.c
--- wine/win32/device.c	2 Dec 2002 18:57:42 -0000	1.74
+++ wine/win32/device.c	5 Dec 2002 13:25:48 -0000
@@ -1899,7 +1899,7 @@
  */
 HANDLE	WINAPI	OpenVxDHandle(HANDLE hHandleRing3)
 {
-	FIXME( "(0x%p), stub! (returning Ring 3 handle instead of Ring 0)\n", hHandleRing3);
+	FIXME( "(%p), stub! (returning Ring 3 handle instead of Ring 0)\n", hHandleRing3);
 	return hHandleRing3;
 }
 